;-- http://radiohlam.ru -  ,   
;------------------------------------------------------------------
 list    p = 12f629
 __config 01FE4h          ;  01111 11 1 1 0 0 100 - (7,8)  , (6)   ,
                          ;  (5)GP3/-MCLR   -MCLR, (4)PWRT , (3)  - , (2-0) - 
;*********  ************************************
         CBLOCK 0x20      ;   
         T_Cr             ; 
         C_imp            ;  
         ENDC             ;
;********  ***************************************
Cr1         equ         .2          ;  1 
Cr0         equ         .4          ;  0 
NCr         equ         .19         ;       (500 uS)
MCr         equ         .53         ;    (1500 us)

Status      equ         03h         ;   .
GPIO        equ         05h         ;    .
Cmcon       equ         19h         ;  Cmcon - 
TrisIO      equ         05h         ;      .
INTCON      equ         0Bh         ;  (1)/(0) 
OSCCAL      equ         10h         ;    
F           equ         1           ;    .
;********************************************************
; GP0 -   , GP1, GP2, GP4, GP5 - 
;********************************************************

          org 0
;********   ********************************************************
;***  ,      , **********
;***    , OSCCAL    03FFh,     BOR - *
;*** 12-,13-    (   BOR - 01, OSCCAL - 3458)*****************
start      
;******   *****************************************************************
            bsf         Status,5    ;
            Call        3FFh        ;     w
            movwf       OSCCAL      ;       
;********     ************************************************
            bcf         Status,5    ;    0
            clrf        GPIO        ;   (   )
            movlw       .7          ;  0..2 
            movwf       Cmcon       ;  , GP0, GP1, GP2 -  /
            bsf         Status,5    ;   1-  (  1 5-   Status)
            movlw       .62         ;   GPIO   (W)    .62=00 111110 GP0 - ,  - 
            movwf       TrisIO      ;   GPIO  W   TrisIO.
            bcf         Status,5    ;   0-  (  0 5-   Status)

;*****    ******************
RCY      movlw   NCr            ;   NCr  
         movwf   C_imp          ;      C_imp
Y_001    movlw   Cr1            ;   Cr1  
         movwf   T_Cr           ;      T_Cr ( )
         bsf     GPIO,0         ;     GP0  ( 1  )
Cr1_Y    decfsz  T_Cr,F         ;    T_Cr  :  f=0 -    ,  f=1 - 
                                ;    T_Cr.     0,    ,   0,  
                                ;    nop
         goto    Cr1_Y          ;    Cr1_Y
         nop
         nop
         bcf     GPIO,0         ;     GP0  ( 0  )
         movlw   Cr0            ;   Cr0  
         movwf   T_Cr           ;      T_Cr
Cr0_Y    decfsz  T_Cr,F         ;
         goto    Cr0_Y          ;
         decfsz  C_imp,F        ;
         goto    Y_001          ;
;*****    *******************
RCN      movlw   MCr            ;   MCr  
         movwf   C_imp          ;      C_imp
N_001    movlw   Cr1            ;
         movwf   T_Cr           ;
         nop                    ;  bsf GPIO
Cr1_N    decfsz  T_Cr,F         ;
         goto    Cr1_N          ;
         nop
         nop
         nop                    ;  bf GPIO
         movlw   Cr0            ;
         movwf   T_Cr           ;
Cr0_N    decfsz  T_Cr,F         ;
         goto    Cr0_N          ;
         decfsz  C_imp,F        ;
         goto    N_001          ;
         goto    RCY            ;
;***********************************************************************************************
        end
